import { ValueOf } from '@pluralsight/ps-design-system-util';
import hoistNonReactStatics from 'hoist-non-react-statics';
import React from 'react';
import { defaultName, names } from '../vars/index';
export { defaultName, names };
declare type Names = typeof names;
export declare const ThemeContext: React.Context<"dark" | "light">;
declare type ThemeProps = {
    name?: ValueOf<Names>;
};
declare type ThemeStatics = {
    defaultName: typeof defaultName;
    names: Names;
};
declare type ThemeComponent = React.FC<ThemeProps> & ThemeStatics;
declare const Theme: ThemeComponent;
export default Theme;
export declare function useTheme(): "dark" | "light";
/**
 * @deprecated please use the useTheme hook to get theme information
 */
export declare function withTheme<T, P extends Record<string, unknown>>(BaseComponent: React.ComponentType<P>): React.ForwardRefExoticComponent<React.PropsWithoutRef<P> & React.RefAttributes<T>> & hoistNonReactStatics.NonReactStatics<React.ComponentType<P>, {}>;
